/* eslint-disable no-magic-numbers */

var version,
  gazeServerURL,
  gameServerURL,
  fps,
  fpsBufferLength,
  screenWidth,
  screenHeight,
  maxGazePointAge,
  gazePointRadius,
  gazePointColor,
  maxNumberOfEnemies,
  enemySpawnDelay,
  playerDamage,
  worldBackgroundColor,
  debugInfoPosition,
  debugInfoFont,
  debugInfoFonColor,
  showDebugInfoOnScreen,
  showVerboseDebugInfoInConsole,
  useMouseInput;

class GameConfiguration {

  constructor() {}

  reset() {
    version = "$VERSION";
    gazeServerURL = "ws://localhost:8001/gaze";
    gameServerURL = "ws://132.199.139.204:2567",
      fps = 60;
    fpsBufferLength = 60;
    screenWidth = screen.width;
    screenHeight = screen.height;
    maxGazePointAge = 500;
    gazePointRadius = 15;
    gazePointColor = "#4cd494";
    maxNumberOfEnemies = 10;
    enemySpawnDelay = 500;
    playerDamage = 100;
    worldBackgroundColor = "#332f3a";
    debugInfoPosition = {
      x: 10,
      y: screenHeight - 10,
    };
    debugInfoFont = "16px ShareTech";
    debugInfoFonColor = "#FFF";
  }

  setVersion(value) {
    version = value;
  }

  getVersion() {
    return version;
  }

  setGazeServerURL(value) {
    gazeServerURL = value;
  }

  getGazeServerURL() {
    return gazeServerURL;
  }

  setGameServerURL(value) {
    gameServerURL = value;
  }

  getGameServerURL() {
    return gameServerURL;
  }

  setFPS(value) {
    fps = value;
  }

  getFPS() {
    return fps;
  }

  setFPSBufferLenght(value) {
    fpsBufferLength = value;
  }

  getFPSBufferLenght() {
    return fpsBufferLength;
  }

  setScreenWidth(value) {
    screenWidth = value;
  }

  getScreenWidth() {
    return screenWidth;
  }

  setScreenHeight(value) {
    screenHeight = value;
  }

  getScreenHeight() {
    return screenHeight;
  }

  setMaxGazePointAge(value) {
    maxGazePointAge = value;
  }

  getMaxGazePointAge() {
    return maxGazePointAge;
  }

  setGazePointRadius(value) {
    gazePointRadius = value;
  }

  getGazePointRadius() {
    return gazePointRadius;
  }

  setGazePointColor(value) {
    gazePointColor = value;
  }

  getGazePointColor() {
    return gazePointColor;
  }

  setMaxNumberOfEnemies(value) {
    maxNumberOfEnemies = value;
  }

  getMaxNumberOfEnemies() {
    return maxNumberOfEnemies;
  }

  setEnemySpawnDelay(value) {
    enemySpawnDelay = value;
  }

  getEnemySpawnDelay() {
    return enemySpawnDelay;
  }

  setPlayerDamage(value) {
    playerDamage = value;
  }

  getPlayerDamage() {
    return playerDamage;
  }

  setWorldBackgroundColor(value) {
    worldBackgroundColor = value;
  }

  getWorldBackgroundColor() {
    return worldBackgroundColor;
  }

  setDebugInfoPosition(value) {
    debugInfoPosition = value;
  }

  getDebugInfoPosition() {
    return debugInfoPosition;
  }

  setDebugInfoFont(value) {
    debugInfoFont = value;
  }

  getDebugInfoFont() {
    return debugInfoFont;
  }

  setDebugInfoFonColor(value) {
    debugInfoFonColor = value;
  }

  getDebugInfoFonColor() {
    return debugInfoFonColor;
  }

  setShowDebugInfoOnScreen(value) {
    showDebugInfoOnScreen = value;
  }

  getShowDebugInfoOnScreen() {
    return showDebugInfoOnScreen;
  }

  setShowVerboseDebugInfoInConsole(value) {
    showVerboseDebugInfoInConsole = value;
  }

  getShowVerboseDebugInfoInConsole() {
    return showVerboseDebugInfoInConsole;
  }

  setUseMouseInput(value) {
    useMouseInput = value;
  }

  getUseMouseInput() {
    return useMouseInput;
  }
}

const Config = new GameConfiguration;
Config.reset();

export default Config;